#!/bin/bash
#
# Tool for verification importing data into database of nucleic acids from mmCIF files
#
# 2011 Ondrej Cecak <ondrej@cecak.cz>, CVUT FEL
# v1.0

cacheDir=../import/cache/
importDir=../import

#ls ../import/cache/ | grep cif | while read file; do 
cat list | while read file; do
  pdb=${file%%.cif}
 
  cd ../import/
  ./import.py $pdb >out 2>out.err

  echo -n "$pdb "

  grep 'Time used' out.err > /dev/null
  if [ $? -eq 0 ]; then
    echo -n "OK"
  else
    echo -n "ERROR"
  fi
  
  grep 'WARNING: expectation of method 2' out > /dev/null
  if [ $? -eq 0 ]; then
    echo " (3DNA)"
  else
    grep 'VERIFY: OK' out > /dev/null
    if [ $? -eq 0 ]; then
      echo " (DOUBLE CHECKED)"
    else
      grep "find_pair return non-zero status" out > /dev/null
      if [ $? -eq 0 ]; then
	echo " (3DNA)"
      else
	grep 'WARNING: LoadStructure failed' out > /dev/null
	if [ $? -eq 0 ]; then
	  echo " (mmLIB)"
	else 
          echo " (SUSPECTED)"
	  cp out out.$file
	fi
      fi
    fi  
  fi
done

