<?php

require_once("config/config.php");
$link = pg_connect("host=$host port=$port dbname=$dbname user=$user password=$password");
if (!$link) {
 echo "<p class='error'>ERROR: internal error, connection to database failed.</p>";
  die();
}

$table = $_REQUEST['table'];
$pdbid = $_REQUEST['id'];

#header("Content-Type: text/plain"); 
header("Content-Type: text/csv"); 
header('Content-Disposition: attachment; filename="nadb-' . $pdbid . '-' . $table . '.csv"');

$query = "SELECT id FROM biomolecule WHERE pdbcode='$pdbid';";
$result = pg_exec($link, $query);
$row = pg_fetch_row($result);
$biomoleculeId = $row[0];

switch($table) {
  case 'Atom':
    $query = "SELECT chain.name, residue.name, residue.position, element, x, y, z FROM biomolecule JOIN chain ON biomolecule.id=chain.biomoleculeId JOIN residue on chain.id=residue.chainId JOIN atom ON residue.id=atom.residueId WHERE biomolecule.pdbcode='$pdbid' ORDER BY residue.position;";
    echo "ICTLabel,chainName,residueName,residuePosition,element,x,y,z\n";
    $result = pg_exec($link, $query);
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[0] . "_" . $row[1] . $row[2] . "," . $row[0] . "," . $row[1] . "," . $row[2]  . "," . $row[3] . "," . $row[4] . "," . $row[5] . "," . $row[6] . "\n";
    }
    break;
  case 'StructureParameter':
    $query = "SELECT residue.name, residue.position, shear, stretch, stagger, buckle, propeller, opening, shift, slide, rise, tilt, roll, twist, chain.name, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN structureParameter ON structureParameter.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    echo "Residue,Shear,Stretch,Stagger,Buckle,Propeller,Opening,Shift,Slide,Rise,Tilt,Roll,Twist\n";
    $result = pg_exec($link, $query);
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[14] . "_" . $row[0] . $row[1] . ',' . $row[2] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . ',' . $row[9] . ',' . $row[10] . ',' . $row[11] . ',' . $row[12] . ',' . $row[13] . "\n";
    }
    break;
  case 'OverlapArea':
    $query = "SELECT residue.name, residue.position, chain.name, i1_i2, i1_i2Ring, i1_j2, i1_j2Ring, j1_i2, j1_i2Ring, j1_j2, j1_j2Ring, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN overlapArea ON overlapArea.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,i1-i2,i1-i2AtomRing,i1-j2,i1-j2AtomRing,j1-i2A,j1-i2AtomRing,j1-j2,j1-j2AtomRing\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . ',' . $row[9] . ',' . $row[10] . "\n";
    }  
    break; 
  case 'OriginMeanNormalVector':
    $query = "SELECT residue.name, residue.position, chain.name, Ox, Oy, Oz, Nx, Ny, Nz, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN originMeanNormalVector ON originMeanNormalVector.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,Ox,Oy,Oz,Nx,Ny,Nz\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . "\n";
    }
    break;
  case 'HelicalParameter':
    $query = "SELECT residue.name, residue.position, chain.name, X_disp, Y_disp, h_Rise, Incl, Tip, h_Twist, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN helicalParameter ON  helicalParameter.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Reisude,X-disp,Y-disp,h-Rise,Incl.,Tip,h-Twist\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . "\n";
    }
    break;
  case 'StepClassification':
    $query = "SELECT residue.name, residue.position, chain.name, Xp, Yp, Zp, XpH, YpH, ZpH, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN StepClassification ON StepClassification.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,Xp,Yp,Zp,XpH,YpH,ZpH\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . "\n";
    }
    break;
  case 'C1GlobalParameter':
    $query = "SELECT residue.name, residue.position, chain.name, disp, angle, twist, rise, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN C1GlobalParameter ON C1GlobalParameter.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,disp.,angle,twist,rise\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . "\n";
    }
    break;
  case 'TorsionAngle':
    $query = "SELECT residue.name, residue.position, chain.name, alpha, beta, gamma, delta, epsilon, zeta, chi, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN torsionAngle ON torsionAngle.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,alpha,beta,gamma,delta,epsilon,zeta,chi\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . ',' . $row[9] . "\n";
    }
    break;
  case 'SugarConformationalParameter':
    $query = "SELECT residue.name, residue.position, chain.name, tm, P, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN sugarConformationalParameter ON sugarConformationalParameter.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,tm,P\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . "\n";
    }
    break;
  case 'PCVirtualBondDistance':
    $query = "SELECT residue.name, residue.position, chain.name, PP, C1C1, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN pCVirtualBondDistance ON pCVirtualBondDistance.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,P--P,C1'--C1'\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . "\n";
    }
    break;
  case 'HelixRadiusRadialDisplacement':
    $query = "SELECT residue.name, residue.position, chain.name, P, O4, C1 FROM chain JOIN residue ON chain.id=residue.chainid JOIN helixRadiusRadialDisplacement ON helixRadiusRadialDisplacement.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,P,O4,C1\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . "\n";
    }
    break;
  case 'PositionAndLocalHelicalAxisVector':
    $query = "SELECT residue.name, residue.position, chain.name, Px, Py, Pz, Hx, Hy, Hz, residue.id FROM chain JOIN residue ON chain.id=residue.chainid JOIN positionAndLocalHelicalAxisVector ON positionAndLocalHelicalAxisVector.residueId=residue.id WHERE biomoleculeId='$biomoleculeId' ORDER BY residue.position;";
    $result = pg_exec($link, $query);
    echo "Residue,Px,Py,Pz,Hx,Hy,Hz\n";
    while ($row = pg_fetch_row($result)) {
      echo $pdbid . "_" . $row[2] . "_" . $row[0] . $row[1] . ',' . $row[3] . ',' . $row[4] . ',' . $row[5] . ',' . $row[6] . ',' . $row[7] . ',' . $row[8] . "\n";
    }
    break;
  default: 
    echo "ERROR: internal error, unknown table $table!";
}

?>
