<?php

// Simple demonstration tool for query the NADB
#
# 2011 Ondrej Cecak <ondrej@cecak.cz>, CVUT FEL
# v1.0.1

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

require_once("config/config.php");
$link = pg_connect("host=$host port=$port dbname=$dbname user=$user password=$password");
if (!$link) {
 echo "<p class='error'>ERROR: internal error, connection to database failed.</p>";
  die();
}

session_start();

$page = $_REQUEST['page'];
if (!isset($page) OR $page == "") {
  $page = "index";
}

$parameter = substr($page, 0, strpos($page, "-"));
if ($parameter == "delete") {
  $parameter = substr($page, 7, 4);
  $page = "delete";
} elseif ($parameter == "detail") {
  $parameter = substr($page, 7, 4);
  $page = "detail";
} elseif ($parameter == "result") {
  $parameter = substr($page, 7, 4);
  $page = "result";
} elseif ($parameter == "browse") {
  $parameter = substr($page, 7, 4);
  $page = "browse";
}

if($_SERVER[SERVER_NAME] != "nadb.cecak.cz"){
  $title = "Nucleic Acids Structure Query Tool";
} else {
  $title = "Nucleic Acids Database";
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title><?php echo $title; ?></title>
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <meta http-equiv="Content-Language" content="en" />
    <link href="/css/style.css" rel="stylesheet" type="text/css" media="screen" />
    <script src="/js/Jmol.js" type="text/javascript"></script>
  </head>
  <body>

  <div id="header">
    <div id="menu">
      <h1 class="title"><?php echo $title; ?></h1>
      <p>
      <?php
        if ($page=="query"){
	  echo '<span class="selected">';
	} else {
	  echo '<span class="menu">';
	  if ($uriRewrites=="yes"){
	    echo '<a href="/query">';
	  } else {
	    echo '<a href="index.php?page=query">';
	  }
	} 
	echo "query";
	if ($page=="query"){
 	  echo '</span> | ';
	} else {
	  echo '</a></span> | ';
	}

        if ($page=="browse"){
          echo '<span class="selected">';
        } else {
          echo '<span class="menu">';
	  if ($uriRewrites=="yes"){
	    echo '<a href="/browse">';
	  } else {
	    echo '<a href="index.php?page=browse">';
	  }
        }
        echo "browse database";
        if ($page=="browse"){
          echo '</span> | ';
        } else {
          echo '</a></span> | ';
        }

        if ($page=="import"){
          echo '<span class="selected">';
        } else {
          echo '<span class="menu">';
          if ($uriRewrites=="yes"){
            echo '<a href="/import">';
          } else {
            echo '<a href="index.php?page=import">';
          }
        }
        echo "import structures";
        if ($page=="import"){
          echo '</span> | ';
        } else {
          echo '</a></span> | ';
        }

        if ($page=="about"){
          echo '<span class="selected">';
        } else {
          echo '<span class="menu">';
	  if ($uriRewrites=="yes"){
	    echo '<a href="/about">';
	  } else {
	    echo '<a href="index.php?page=about">';
	  }
        }
        echo "about";
        if ($page=="about"){
          echo '</span>';
        } else {
          echo '</a></span>';
        }
      ?>
      </p>
    </div>
  </div>

  <?php
    if (!file_exists("pages/$page.html")){
      $page = "not-found";
    }
    echo '<div id="content">';
      include "pages/$page.html";
    echo '</div>';
  ?>

  </body>
</html>

